// укажите имя драйвера Modbus в дереве проекта:
var gDriver = IR.GetDevice("Modbus TCP");

// укажите спиок графических элементов которые будут управлять указанными здесь битами регистров:
var gRegisters = [
   {item: IR.GetItem("Page 1").GetItem("1"), tag:"1", bit:0},   // элемент, регистр, бит регистра
   {item: IR.GetItem("Page 1").GetItem("2"), tag:"1", bit:1},
   {item: IR.GetItem("Page 1").GetItem("3"), tag:"1", bit:2},
   {item: IR.GetItem("Page 1").GetItem("4"), tag:"1", bit:3},
   {item: IR.GetItem("Page 1").GetItem("5"), tag:"1", bit:4},
   {item: IR.GetItem("Page 1").GetItem("6"), tag:"2", bit:0},
   {item: IR.GetItem("Page 1").GetItem("7"), tag:"2", bit:1}
];

//------------------------ рабочий код, не изменять ----------------------------
function SetBit(register, num)
{
   return register | (1 << num);
}

function Unset(register, num)
{
   return register & ~(1 << num);
}

function GetBit(register, num)
{
   return (register >> num) & 1;
}

// при нажатии на кнопку. this - указатель на элемент
function OnPress()
{
   for(var i = 0; i < gRegisters.length; i++)
   {
      if(gRegisters[i].item == this)
      {
         var register = gDriver.GetFeedback(gRegisters[i].tag);
         var new_val = 0;
                  
         if(this.Value == 0)
            new_val = Unset(register, gRegisters[i].bit);
         else
            new_val = SetBit(register, gRegisters[i].bit);
            
         gDriver.Set(gRegisters[i].tag, new_val);
         break;
      }
   } 
}

// при получении обратной связи
function OnRecieve(name, dec_value)
{
   for(var i = 0; i < gRegisters.length; i++)
   {
      if(gRegisters[i].tag == name)
      {
         IR.Log(name);
         var val = GetBit(dec_value, gRegisters[i].bit);
         gRegisters[i].item.Value = val;
      }
   }
}

// регистрация кнопок
function RegisterButton()
{ 
   for(var i = 0; i < gRegisters.length; i++)
   {
      var item = gRegisters[i].item;
      IR.AddListener(IR.EVENT_ITEM_PRESS, item, OnPress, item);
   }
}

// регистрация обратной связи
function RegisterTagListener()
{
   IR.AddListener(IR.EVENT_TAG_CHANGE, gDriver, OnRecieve);
}

// функция, выполняющаяся по старту
function Start()
{
   RegisterButton();
   RegisterTagListener();
}
 
IR.AddListener(IR.EVENT_START,0, Start);